#include <bits/stdc++.h>
//#define endl '\h'
#define se second
#define fi first


using namespace std;
const long long dim=500007  ;


long long n, m,a[dim],l,r,c,res,sum;
bool sumLR(long long L, long long R){
    if(L>R){
        long long tmp=0;
        for(int ti=L;ti<=R;ti++){
            tmp+=a[ti];
            if(tmp<0)return 0;
        }
    }
    else{
        long long tmp=0;
        for(int ti=R;ti>=L;ti--){
            tmp+=a[ti];
            if(tmp<0)return 0;
        }
    }

    return 1;

}
void getAns(){

    cin >>l >> r;
    c=1;
  //  cout << sumLR(1,4) << " " << sumLR(4,1) << endl;
    for(long long i=l;i<=r;i++){
        for(long long j=i+1;j<=r;j++){
            if(sumLR(i,j) && sumLR(j,i))c=max(c,j-i+1);
        }
    }
    cout << c<< endl;
}
int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n >> m;
    for(int i=1;i<=n;i++){
        cin >> a[i];
    }
    int question;
    for(int ki=1;ki<=m;ki++){
        cin >> question;
        if(question ==1){
            cin >> question;
            a[question]*=-1;
        }
        else{
            getAns();
        }
    }



    return 0;
}
/*

4 1
1 -1 -1 1
2 1 4
2
*/
